*
      SUBROUTINE CAL_GESVD2(NAME, SV, M, N, NPROW, NPCOL, AMEM,
     $                      MEMSIZE, NB, INFILEA, OUTFILE)
*
*      PDGESVD2(3,5,6)
*       
*   
*
      include 'mpif.h'
*
*  
      INTEGER            M, N, NPROW, NPCOL, NB, MEMSIZE
      DOUBLE PRECISION   AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, OUTFILE, NAME, SV
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, INFO, IPA, IPS,
     $                   IPW, IPWOR, IPU, IPVT, NP, NQ, NP0, NQ0, MP0,
     $                   MYCOL, MYROW, MXNP, MXNQ, LWORK,
     $                   IA, JA, IU, JU, IVT, JVT, NPROCS, MMIN, NRU,
     $                   LWMIN, MAXIM, MP, NCVT,
     $                   WORKSIZ, SIZE, SIZEB, SIZEP, SIZEQ, SIZEVT,
     $                   WANTU, WANTVT, WATOBD, WBDTOSVD, WDBDSQR,
     $                   WPDGEBRD, WPDLANGE, WPDORMBRPRT, WPDORMBRQLN
*  
      INTEGER            DESCA( 9 ), DESCU( 9 ), DESCVT( 9 )
*
*  
      LOGICAL            LSNAME
      INTEGER            NUMROC
      EXTERNAL           NUMROC, LSNAME
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, IGSUM2D, PDLAPRNT,
     $                   PDLAREAD, PDLAWRITE,
     $                   PDGESVD2, PDGESVD3, PDGESVD5, PDGESVD6
*
*  
      INTRINSIC          MAX, MIN
*
*  
*
*  
*
      IA = 1
      JA = 1
      IU = 1
      JU = 1
      IVT = 1
      JVT = 1
*
      SIZE = MIN( M, N )
      SIZEB = MAX( M, N )
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
*           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       MP = NUMROC( M, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
*      A, U, VT
*
      CALL DESCINIT(DESCA, M, N, NB, NB, 0, 0, CTXT, MAX(1,MP), INFO)
      CALL DESCINIT(DESCU, M, SIZE, NB, NB, 0, 0, CTXT, MAX(1,MP),INFO)
*
         IF( LSAME( SV, 'R' ) ) THEN
            WANTU = 1
         ELSE
            WANTU = 0
         END IF
         IF( LSAME( SV, 'L' ) ) THEN
            WANTVT = 1
         ELSE
            WANTVT = 0
         END IF
*
         IF( LSAME( SV, 'A' ) ) THEN
            WANTVT = 1
            WANTU = 1
         END IF
*
*     AMEM
*
*     A
      IPA = 1
*
*     S (   )
      IPS = IPA + DESCA(9)*NQ
*     WORK
      IPWOR = IPS + N
*
      MP0 = NUMROC( M, NB, 0, 0, NPROW )
      NQ0 = NUMROC( N, NB, 0, 0, NPCOL )
*
      MAXIM = MAX( MP0, NQ0 )
*
      NRU = NUMROC( SIZE, 1, 0, 0, NPROW*NPCOL )
      NCVT = NUMROC( SIZE, 1, 0, 0, NPROW*NPCOL )
*
      WPDLANGE = MP
      WPDGEBRD = NB*( MP+NQ+1 ) + NQ
      WATOBD = MAX( MAX( WPDLANGE, WPDGEBRD ), MAXIM )
*
    2 IF( NAME .NE. 'PDGESVD2' .AND. NAME .NE. 'PDGESVD5' ) GOTO 5
*
      SIZEP = NUMROC( M, NB, MYROW, 0, NPROW )
      SIZEQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
***
      SIZEVT = NUMROC( SIZE, NB, MYROW, 0, NPROW )
*
      CALL DESCINIT( DESCVT, SIZE, N, NB, NB, 0, 0, CTXT,
     $ MAX(1, SIZEVT), INFO )
*
      IPU = IPS + N
      IPVT = IPU + DESCU(9)*SIZEQ
      IPWOR = IPVT + SIZEP*NQ
*
      WDBDSQR = MAX( 1, 2*SIZE+( 2*SIZE-4 ) )
      WPDORMBRQLN = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEQ+MP )*NB ) +
     $                    NB*NB
      WPDORMBRPRT = MAX( (NB*( NB-1 ) ) / 2, ( SIZEP+NQ )*NB ) +
     $                    NB*NB
      WBDTOSVD = SIZE*( NRU+NCVT ) +
     $                 MAX( WDBDSQR, MAX( WPDORMBRQLN, WPDORMBRPRT ) )
*
      LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD2(5)
      LWORK = LWMIN
*
      GO TO 3
*
    5 IF( NAME .NE. 'PDGESVD3' .AND. NAME .NE. 'PDGESVD6' ) GOTO 10
*
      IF( WANTVT.EQ.1 ) THEN
         SIZEP = NUMROC( SIZE, NB, MYROW, 0, NPROW )
      ELSE
         SIZEP = 0
      END IF
      IF( WANTU.EQ.1 ) THEN
         SIZEQ = NUMROC( SIZE, NB, MYCOL, 0, NPCOL )
      ELSE
         SIZEQ = 0
      END IF
*
      SIZEVT = NUMROC( SIZE, NB, MYROW, 0, NPROW )
*
      CALL DESCINIT( DESCVT, SIZE, N, NB, NB, 0, 0, CTXT,
     $ MAX(1,SIZEVT), INFO)
*
      IF( WANTU.EQ.1 .AND. WANTVT.EQ.0 ) THEN
         IPU = IPS + SIZE
         IPWOR = IPU + DESCU(9)*SIZEQ
      END IF
      IF( WANTU.EQ.0 .AND. WANTVT.EQ.1 ) THEN
         IPVT = IPS + SIZE
         IPWOR = IPVT + SIZEP*NQ
      END IF
      IF( WANTU.EQ.1 .AND. WANTVT.EQ.1 ) THEN
         IPU = IPS + SIZE
         IPVT = IPU + DESCU(9)*SIZEQ
         IPWOR = IPVT + SIZEP*NQ
      END IF
*
      WDBDSQR = MAX( 1, 2*SIZE+( 2*SIZE-4 )*MAX( WANTU, WANTVT ) )
      WPDORMBRQLN = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEQ+MP )*NB ) +
     $               NB*NB
      WPDORMBRPRT = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEP+NQ )*NB ) +
     $                    NB*NB

      WBDTOSVD = SIZE*( WANTU*NRU+WANTVT*NCVT ) +
     $           MAX( WDBDSQR, MAX( WANTU*WPDORMBRQLN,
     $           WANTVT*WPDORMBRPRT ) )
*
      IF( NAME .NE. 'PDGESVD3' ) GOTO 7
*
      LWMIN = 2 + 6*N + MAX( WATOBD, WBDTOSVD )
      GO TO 8
*
    7 LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD3(6)
    8 LWORK = LWMIN
*
      GO TO 3
* 
*     W
*
    3 IPW = IPWOR + LWORK
*
*     PDLAPRNT  .
*?
      WORKSIZ = MAX( NB, MP )
*
*        
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN') 
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         GO TO 10
      END IF
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )M, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = 9995 )INFO, SV
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'IPA, IPS, IPU,IPVT,IPWOR,IPW,LWORK, MMIN'
         WRITE( NPR, FMT = 9994 )IPA,IPS,IPU,IPVT,IPWOR,IPW,LWORK,MMIN
*
         WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
        IF( WANTU.NE.1 ) GO TO 21
         WRITE( NPR, FMT = * ) '  DESCU'
         WRITE( NPR, FMT = 9985 )DESCU
   21   IF( WANTVT.NE.1 ) GO TO 22
         WRITE( NPR, FMT = * ) '  DESCVT'
         WRITE( NPR, FMT = 9985 )DESCVT
   22    WRITE( NPR, FMT = * ) '  A'
      END IF
*
*         A
*
      CALL PDLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
*
      CALL PDLAPRNT( M, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
 9994 FORMAT( / I3, 7I5 /)
 9985 FORMAT( / 9I5 /)
*
*       
*   
*
      IF( NAME .EQ. 'PDGESVD2' ) GOTO 11
      IF( NAME .EQ. 'PDGESVD3' ) GOTO 15
      IF( NAME .EQ. 'PDGESVD5' ) GOTO 16
      IF( NAME .EQ. 'PDGESVD6' ) GOTO 17
      GO TO 10
*
   11 CALL PDGESVD2( N, AMEM(IPA), IA, JA, DESCA, AMEM(IPS), AMEM(IPU),
     $               IU, JU, DESCU, AMEM(IPVT), IVT, JVT, DESCVT,
     $               AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   15 CALL PDGESVD3( SV, N, AMEM(IPA), IA, JA, DESCA, AMEM(IPS),
     $               AMEM(IPU), IU, JU, DESCU, AMEM(IPVT), IVT, JVT,
     $               DESCVT, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   16 CALL PDGESVD5( M, N, AMEM(IPA), IA, JA, DESCA, AMEM(IPS),
     $               AMEM(IPU), IU, JU, DESCU, AMEM(IPVT), IVT, JVT,
     $               DESCVT, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
   17 CALL PDGESVD6( SV, M, N, AMEM(IPA), IA, JA, DESCA, AMEM(IPS),
     $               AMEM(IPU), IU, JU, DESCU, AMEM(IPVT), IVT, JVT,
     $               DESCVT, AMEM(IPWOR), LWORK, INFO )
      GOTO 99
*
*  
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
         WRITE( NPR, FMT = 9995 )INFO, SV
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
         WRITE( NPR, FMT = * ) '   '
*
         DO 12 I = IPS, IPS+SIZE-1
         PRINT *, ' S(', I-IPS+1, ')=', AMEM( I ), ';'
   12   CONTINUE
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( SV.EQ.'R' .OR. SV.EQ.'A' ) THEN
            WRITE( NPR, FMT = * ) '  U'
         END IF
      END IF
      IF( SV.EQ.'R' .OR. SV.EQ.'A' ) THEN
      CALL PDLAPRNT( M, SIZE, AMEM(IPU), IU, JU, DESCU, 0, 0, 'U', NPR,
     $               AMEM(IPW) )
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( SV.EQ.'L' .OR. SV.EQ.'A' ) THEN
            WRITE( NPR, FMT = * ) '  VT'
         END IF
      END IF
      IF( SV.EQ.'L' .OR. SV.EQ.'A' ) THEN
      CALL PDLAPRNT( SIZE, N, AMEM(IPVT), IVT, JVT, DESCVT, 0, 0, 'VT',
     $               NPR, AMEM(IPW) )
      END IF
*
*     
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         WRITE(NOUT, FMT = *)'   '
         WRITE(NOUT, FMT = *)'   '
*
         WRITE(NOUT, FMT = *) SIZE, 1
         DO 14 I = 1, SIZE
            WRITE( NOUT, FMT = * ) AMEM( IPS+I-1 )
   14    CONTINUE
*
         IF( SV.EQ.'R' .OR. SV.EQ.'A' ) THEN
            WRITE( NOUT, FMT = * ) '  U'
         END IF
      END IF
*
      IF( SV.EQ.'R' .OR. SV.EQ.'A' ) THEN
*
      CALL PDLAWRITE( OUTFILE, M, SIZE, AMEM(IPU), IU, JU, DESCU,
     $                0, 0, AMEM(IPW) )
      END IF
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         IF( SV.EQ.'L' .OR. SV.EQ.'A' ) THEN
            WRITE( NOUT, FMT = * ) '  VT'
         END IF
      END IF
      IF( SV.EQ.'L' .OR. SV.EQ.'A' ) THEN
*
      CALL PDLAWRITE( OUTFILE, SIZE, N, AMEM(IPVT), IVT, JVT, DESCVT,
     $                0, 0, AMEM(IPW) )
      END IF
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A8 )
 9998 FORMAT( / '   ',
     $      '     A,'//
     $       '  A  -   ',I2,'  ',I2,',',
     $       /'         ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9995 FORMAT( /'  INFO =',I5,'  SV = ',A1, /)
 9984 FORMAT( / ' LWORK  = ', D7.17 /)
      RETURN
      END
